package skiplist.model;

import java.util.Iterator;
import java.util.Optional;

public class SkipListIterator<E extends Comparable<E>> implements Iterator<E> {
	private Optional<SkipNode<E>> current;
	
	public SkipListIterator(Optional<SkipNode<E>> node) {
		current = node;
	}
	
	@Override
	public boolean hasNext() {
		return current.isPresent();
	}

	@Override
	public E next() {
		E value = current.get().getData().get();
		current = current.get().getNext(0);
		return value;
	}

}
