package skiplist.model;

import static org.junit.Assert.*;

import org.junit.Test;

public class SkipListTest {

	@Test
	public void testAdd() {
		SkipList<String> list = new SkipList<>();
		list.add("d");
		list.add("a");
		list.add("g");
		list.add("b");
		list.add("f");
		list.add("c");
		list.add("e");
		String result = "";
		for (String s: list) {
			result += s;
		}
		assertEquals("abcdefg", result);
	}

	// Takes a few seconds to run.
	@Test
	public void testHeight() {
		for (int n = 0; n < 30; n++) {
			SkipList<Integer> list = new SkipList<>();
			for (int i = 0; i < 65536; i++) {
				list.add((int)(Integer.MAX_VALUE * Math.random()));
			}
			assertTrue(13 <= list.getHeight() && list.getHeight() <= 25);
			int last = Integer.MIN_VALUE;
			for (int value: list) {
				assertTrue(value >= last);
				last = value;
			}
		}
	}
}
